// --- [ main.c ] ------------------------------------------------------------
//
// tab = 3
#define EXTERN
#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include "ftd2xx.h"
#include <dos.h>
#include <time.h>
#include "ftdi.h"
#include "xbee_api.h"
#include "parser.h"
#include "global.h"

#ifdef IS_CONIO2_LIB
	#include <conio2.h>
#endif
// --- globale Variablen ---
unsigned int devices = 0;

extern char target_adr[DEVICES][8];
extern char target_network_adr[DEVICES][2];

unsigned int parameter_to_hex(unsigned char * txt);
unsigned char read_xbee_adresses(void);
void print_xbee_adresses(void);
void show_prompt(void);
unsigned int getmyline(unsigned char * input);

// ----------------------------------------------------------------------------
// ffnet die serielle Schnittstelle, liest die Target-Adressen aus einer Datei ein
// und arbeitet dann in einer Endlosschleife
int main(int argc, char* argv[])
{
LONG COMPORT = 0;
char COMx[5];
unsigned int i;
frame_id         = 0;                     // fortlaufende ID der Messages
last_frame_id    = 0;                     // die zuletzt versandte msg_id
const_frame_id_0 = FALSE;                 // fortlaufende Frame_id > 0 vergeben
verbosed         = 2;                 		// Anzeige aller gesendeter/empfangener Bytes
clear_screen     = TRUE;                  // den Bildschirm nach jeder Eingabe lschen
rm_device        = 0;                     // Koordinator als default-Target

ftStatus = FT_Open(0, &ftHandle);

if(ftStatus != FT_OK)
	{
	printf("opening failed! error: %d\n", ftStatus);
	printf("No FTDI-USB-Seriell-Adapter found\n");
	getchar();
	return 1;
	}

ftStatus = FT_GetComPortNumber(ftHandle,&COMPORT);

if(ftStatus != FT_OK)
	{
   printf("ftHandle: %i\n", ftHandle);
	printf("comport : %i\n", COMPORT);
	printf("ftStatus: %i\n", ftStatus);
	getchar();
	return 1;
	}

if (COMPORT == -1)
	{
	printf("no com port installed \n");
	getchar();
	}

else
	{
	printf("COM Port   : %d\n", COMPORT);
	}

GetDevice_Info();
SetDevice_Baudrate();
if (!(read_xbee_adresses() == TRUE)) return(1);

while(1)                               // Hauptschleife
	{
	if (get_data() == 0) break;
	}

FT_Close(ftHandle);

return 0;
}


// ----------------------------------------------------------------------------
// pollt solange die serielle Schnittstelle und die Tastatur bis:
// - die serielle Schnittstelle Daten geliefert hat,
// - oder eine Tastatureingabe erkannt wird.
// liest die serielle Eingabe nach rs232_in[]
// liest die Tastatureingabe nach msg[]
unsigned int get_data(void)
{
DWORD dwRead, bytes_read;
unsigned int l, i, kb_flag, rs_flag;
unsigned int bytes, last_byte;
unsigned int txt_len;
char lf[2] = {10,0};
char char_received;
unsigned char txt[30];                    // Hier steht die Eingabe aus der Kommandozeile,
                                          // aber umgewandelt in Grossschreibung
kb_flag = rs_flag = FALSE;
l = 0;                                    // Index fr msg[]
while(1)                                  // Hauptschleife
	{
#ifdef IS_CONIO2_LIB
	textcolor(WHITE);
#endif
// ein Prompt ausgeben, fhrend ist die Adresse der gewhlten Gegenstelle
/*	printf("\n\n[ ");
	for (i = 0; i < 8; i++) printf("%X ", (unsigned char) target_adr[rm_device][i]);
	printf("] XBee #%d -> ", rm_device);
*/
	printf("\n\n");
	show_prompt();

   while(1)                      	    // Schleife, um Tastatur und serielle Schnittstelle zu pollen
      {
// --- zuerst die serielle Schnittstelle abfragen -------------------------------
      bytes_read = GetRx_Bytes();
      if (bytes_read > 0)
         {
         last_byte = 0;                   // Zhler zurckstellen
         bytes = 0;
         do
	        {
	        ftStatus = FT_Read(ftHandle, &rs232_in[bytes], bytes_read, &dwRead);
           if (ftStatus != FT_OK) break;       	// beenden, wenn ein Fehler vorliegt.
	        bytes += dwRead;              // Anzahl der gelesenen Bytes

	        if (last_byte == 0)            // wenn die Framelnge noch nicht gelesen wurde
		       {
		       if (bytes > 2)               // wenn mindestens 3 Byte gelesen sind
			      {                          // die Anzahl der erwarteten Bytes bestimmen
			      last_byte = rs232_in[2] + (3 + 1);// den Index des letzten Bytes bestimmen
			      }
		       }
													  // beenden, wenn genau die erwarteten Bytes eingetroffen sind
	        if ((last_byte > 0) && (bytes == last_byte))
//	        if ((last_byte > 0) && (bytes >= last_byte))
              {
              rs_flag = TRUE;
              break;                     // beendet das Einlesen in do{} while
              }

													  // wenn mehr als die erwarteten Bytes eingetroffen sind
	        else if ((last_byte > 0) && (bytes > last_byte))
              {
              if ((last_byte - bytes) > 2)
                  {
                  last_byte = last_byte + rs232_in[last_byte + 3];
                  }
              if (bytes == last_byte)
                  {
                  rs_flag = TRUE;
                  break;                   // beendet das Einlesen in do{} while
                  }
              }

	         delay_ms(100);                 // Pause einlegen, damit ggf. ein Datensatz vollstndig wird
            } while(bytes_read = GetRx_Bytes()); // einlesen, solange wie noch Daten folgen
         }

 // --- die Tastatur abfragen --------------------------------------------------
   if (kbhit())                           // prfen, ob Eingabe vorliegt
      {
      //scanf("%s", msg);                   // Eingabe nach msg[] einlesen
		// scanf() liest keine Leerzeichen ...
	   while (!(l = getmyline(msg)));        // solange wie die Lnge der Eingabe == 0
      kb_flag = TRUE;
      }                                   // if (kbhit())

   if (kb_flag || rs_flag) break;
   }                                      // while(1)
      
// die Daten stehen in rs232_in[]
   if (rs_flag == TRUE)                   // Daten der seriellen Schnittstelle bearbeiten
      {
      rs_flag = FALSE;
      rs232_print_received(bytes, last_byte);
      }

// die eingegebenen Daten stehen in msg[], l ist der Index auf das nchste frei Byte
   if (kb_flag == TRUE)                   // Tastatureingabe interpretieren
      {
      kb_flag = FALSE;

		if (clear_screen) system("CLS");               // den Bildschirm lschen
//      if (l == 0) continue;

		if ((msg[0] == '#') && (l == 2))          // zwei Zeichen beginnend mit '#' = Programmeinstellung
			{
#ifdef IS_CONIO2_LIB
	textcolor(LIGHTGREEN);
#endif

         if (isdigit(msg[1])) 					// ein anderes Target einstellen
            {
            l = msg[1] - '0';

	         if (l < devices) rm_device = l; else printf("\nInvalid Device #%d\n", l);
	         printf("\nNew Target : %d", rm_device);
	         printf("\nDestination: ");
	         for (l = 0; l < 8; l++) printf("%X ", (unsigned char) target_adr[rm_device][l]);
	         printf("\nNetworkadr : ");
	         for (l = 0; l < 2; l++) printf("%X ", (unsigned char) target_network_adr[rm_device][l]);
	         printf("\n");
            }

			else if (msg[1] == '?') print_xbee_adresses();

      	else if (msg[1] == '-') system("CLS");

      	else if ((msg[1] & 0xDF) == 'A')      // Bildschirm lschen
         	{
				if (clear_screen)
					{
            	printf("\nBildschirm manuell mit '#-' loeschen");
            	clear_screen = FALSE;
					}
				else
					{
	         	printf("\nBildschirm nach jeder Eingabe loeschen");
   	      	clear_screen = TRUE;
      	   	}
				}

      	else if ((msg[1] & 0xDF) == 'F')    // fortlaufende Frame-ID-Nummerierung
         	{
				if (const_frame_id_0)
					{
       	  		printf("\nFrame_ID fortlaufend ( <> 0 )");
           		const_frame_id_0 = FALSE;
           	}
	      	else
					{
           		printf("\nFrame_ID == 0 (keine Empfangsbestaetigung)");
           		const_frame_id_0 = TRUE;
           		}
				}

      	else if ((msg[1] & 0xDF) == 'V')   // ausfhrliche Anzeige aller bertragener Bytes
				{
				if ((++verbosed) > 2) verbosed = 0;
				printf("\nAnzeige uebertragender Bytes ");
				if (verbosed == 1) printf("kurz");
				else if (verbosed == 2) printf("lang");
				else printf("AUS");
         	}     // if  (msg[1] == ...)
			}        // if ((msg[0] == '#') && (l == 2))

		else        // Lokale / Remote AT-Kommands und TRANSMIT REQUESTS
         {
         if ((msg[0] == '+') && (msg[1] == '+') && (l > 3)) // Testen auf ++ = lokales AT-CMD
	        {
#ifdef IS_CONIO2_LIB
	textcolor(LIGHTCYAN);
#endif
			  msg[2] = toupper(msg[2]);		// die beiden Buchstaben des AT-CMD in Grobuchstaben umwandeln
			  msg[3] = toupper(msg[3]);		// das ist nur Kosmetik ohne inhaltliche Bedeutung !

			  printf("\nLocal AT-Command: %s", &msg[2]);// das AT-Command ohne ++ ausgeben
	        l = parameter_to_hex(msg);     // die Parameter konvertieren
	        API_at_cmd(msg, l);				// die Lnge des AT-Befehls-Strings bergeben
           }

         else if ((msg[0] == '#') && (msg[1] == '#') && (l > 3)) // Testen auf ## = remote AT-CMD
           {
#ifdef IS_CONIO2_LIB
	textcolor(LIGHTCYAN);
#endif
			  msg[2] = toupper(msg[2]);		// die beiden Buchstaben des AT-CMD in Grobuchstaben umwandeln
			  msg[3] = toupper(msg[3]);		// das ist nur Kosmetik ohne inhaltliche Bedeutung !

           printf("\nRemote AT-Command: %s", &msg[2]); // das AT-Command ohne ## ausgeben
           l = parameter_to_hex(msg);      // die Parameter konvertieren
           API_remote_at_cmd_request(rm_device, msg, l);  // Adresse und Command
           }

         else           // wenn kein AT-CMD erkannt wird, dann wird ein TRANSMIT REQUEST gesendet
           {
#ifdef IS_CONIO2_LIB
	textcolor(LIGHTCYAN);
#endif

           printf("\nZigBee Transmit Request: %s", msg);
           parse(msg, txt, &txt_len);     // Zahlenfolgen erkennen und in Bytes umwandeln nach txt schreiben
           API_Tx_Request(rm_device, txt, txt_len);
           }
         }
      }                                // if kb_flag
   }                                   // while (j == TRUE)
   return(0);
}

// ----------------------------------------------------------------------------
// wandelt den optionalen Parameter eines AT-Kommandos
// als hexadezimalen Zahlenstring in eine Bytefolge um
// die Eingabe kann in beliebigem Zahlenformat erfolgen
unsigned int parameter_to_hex(unsigned char * txt)
{
unsigned int i, j, str_len;
char txt2[10];

i = strlen(txt);                          // die Lnge der Zeichenfolge
if (i == 4) return(i);                    // beenden, wenn kein Parameter vorhanden

parse(&txt[4], txt2, &str_len);				// die Parameter beginnen mit dem 5. Byte
j = 0;

// die konvertierten Daten aus txt2 werden in txt kopiert
for (i = 4; i < (str_len + 4); i++)  txt[i] = txt2[j++];

return (4 + str_len);
}

// ----------------------------------------------------------------------------
unsigned char hex_to_dez(unsigned char h)
{
unsigned char d;
if (h <= '9') d = h - '0'; else d = h - 'A' + 10;
return(d);
}

// ----------------------------------------------------------------------------
// Liest die 8 Byte Seriennummern sowie die Netzwerkadressen der Radios aus
// der Datei 'xbee_adr.cfg' ein.
// vorbelegt sind bereits fr :
// Device#0 = Coordinator (default)
// Device#1 = Broadcast
unsigned char read_xbee_adresses(void)
{
FILE *file;
unsigned char i, j, x, z;
unsigned int c;

if ((file = fopen("xbee_adr.cfg", "r")) == NULL)
	{
	printf("can't open 'xbee_adr.cfg'\n");
	getchar();                             // auf Eingabe warten
	}

else                                      // Daten ab einlesen
	{
   z = 2;
	i = j = 0;
	
// in der ersten Zeile muss die Anzahl der Targets in Ziffernform stehen
// die Zahl wird mit '#' beendet
   devices = 0;
   while(((c = getc(file)) != EOF))
      {
      if (c == '#') break;                // die Anzahl muss direkt mit '#' abgeschlossen sein !
      if (!(isdigit(c)))
			{
			printf("\nError in 'xbee_adr.cfg'\n");
			getchar();
			getchar();
			return(FALSE);
			}
      devices *= 10;                      // die Ziffernfolge in Zahl umwandeln
      devices += (c - '0');
      }
   devices += 2;                          // 2 addieren fr Coordinator und Broadcast

   if (devices > DEVICES)
      {
      printf("\nError: DEVICES in 'global.h' kleiner als in 'xbee_adr.cfg'");
      getchar();
      getchar();
      return(FALSE);
      }
      
	while(((c = getc(file)) != EOF) && (z < devices))
		{
		if (c < '0') continue;                  // CR, LF etc. ignorieren

      if (!(isxdigit(c)))
			{
			printf("\nInvalid character in 'xbee_adr.cfg'\n");
			getchar();
			getchar();
			return(FALSE);
			}

		if ((i % 2) == 0) x = hex_to_dez(c) * 16; // Gerade Stelle
		else                                   // ungerade Stelle
			{
			x += hex_to_dez(c);
			if (j < 8) target_adr[z][j] = x;
			else target_network_adr[z][j-8] = x;
			j++;
			if (j > 9)
				{
				j = 0;
				z++;
				}
			}
		i++;
		}
	fclose(file);
	}
	print_xbee_adresses();
	return(TRUE);
}

// ----------------------------------------------------------------------------
// XBee-Adressen und Hilfe ausgeben
void print_xbee_adresses(void)
{
unsigned int j, z;

#ifdef IS_CONIO2_LIB
	textcolor(LIGHTGREEN);
#endif

for (z = 0; z < devices; z++)             // gibt die gesamten Daten aus
	{
	printf("\nXBee #%X: ", z);
	for (j = 0; j < 10; j++)
		{
		if (j == 0) printf("Device Adr: ");
		if (j == 8) printf("Network Adr: ");
		if (j < 8) printf("%X ", (unsigned char) target_adr[z][j]);
		else printf("%X ", (unsigned char) target_network_adr[z][j-8]);
		}
	}

printf("\n\n##ab  =  REMOTE  AT-Cmd 'ab' ausfuehren");
printf("\n++ab  =  LOCAL   AT-Cmd 'ab' ausfuehren");
printf("\nabcd  =  den String 'abcd' an das gewaehlte XBee senden");
printf("\n10    =  Eingabe dezimal, 0x10 hexadezimal, O77 oktal, 0b111 binaer");
printf("\n\\10   =  Eingabe der Ziffernfolge '10'");
printf("\n128S  =  's/S' erzwingt einen  8Bit-Wert");
printf("\n128L  =  'l/L' erzwingt einen 16Bit-Wert");
printf("\n128W  =  'w/W' erzwingt einen 32Bit-Wert");
printf("\n#x    =  XBee #'x' als Ziel fuer AT-Remote-Cmd auswaehlen");
printf("\n#-    =  Bildschirm loeschen");
printf("\n#A    =  Bildschirm manuell loeschen / nach jeder Eingabe loeschen");
printf("\n#F    =  konstante Frame_ID = 0 / Frame_ID fortlaufend");
printf("\n#V    =  gesendete + empfangene Bytes anzeigen aus/kurz/lang");
printf("\n#?    =  diese Hilfe ausgeben");
printf("\n^c    =  Programm beenden (Ctrl-C)");
}

// ----------------------------------------------------------------------------
unsigned int getmyline(unsigned char * input)
{
unsigned int size, c, i;

while(1)
	{
	size = LEN_MSG;               // die Lnge des Arrays msg[], das die Eingabe aufnimmt
	i = 0;
	//while(((--size > 0) && (c=getchar())) != EOF && c != '\n') input[i++] = c;
	while(((--size > 0) && ( c=getchar() )) && c != '\n') input[i++] = c;
	//if (c == '\n') input[i] = 0;

	if(i)
		{
		input[i] = 0;
		break;
		}
	else
		{
		show_prompt();
		}
	}
return(i);
}

// ----------------------------------------------------------------------------
// gibt ein Prompt aus mit der Seriennummer des angewhlten Ziels

void show_prompt(void)
{
unsigned int i;

printf("[ ");
for (i = 0; i < 8; i++) printf("%X ", (unsigned char) target_adr[rm_device][i]);
printf("] XBee #%d -> ", rm_device);
}

// ----------------------------------------------------------------------------
// wartet im 1 Millisekunden-Takt
void delay_ms(unsigned int ticks)
{
	clock_t time_start, time_end;

	time_start = clock();
	do {
		time_end = clock();
		}
		while ( (time_end - time_start) < ticks);
}
// --- [ end of file ] --------------------------------------------------------
